local toc, privateData = ...
local AddonId = toc.identifier

EM.UI.Archive = {}
EM.Archive = {}

function  EM.UI.SetupArchiveTab()

	local archiveTab = EM.UI.Archive:getElement()

	archiveTab.Grid = NK.CreateFrame('nkExtGrid', 'MessageGrid', archiveTab,
		{	fontsize = 13, wheelFunc = function(counter) archiveTab.ScrollBar:SetPosition(counter) end,
			color = {	headerBody = '', headerLabel = 'FFFFFF',
						label = 'FFFFFF', border = '000000', body = '222222', 
						bodyhighlight = 'FFFFFF', labelhighlight = '000000' },
			anchors = {	{ from = 'TOPLEFT', object = archiveTab, to = 'TOPLEFT', x = 10, y = 0 }}
		})
		
		local cols = {	{	align = 'center', texture = true, type = 'EasyMail', path = 'gfx/new-mail.png',
							width = 23, textureWidth = 17, textureHeight = 17 },
						{	align = 'left', header = 'From', width = 80 },
						{	align = 'left', header = 'Subject', width = 210 },
						{	align = 'center', sortable = false, width = 20 },
						{	align = 'left', header = 'Deleted', width = 61}}
						
		archiveTab.Grid:layout( cols, 20, {headerHeight = 35})
		
	archiveTab.ScrollBar = UI.CreateFrame("RiftScrollbar", "archiveScrollBar", archiveTab.Grid:getElement(false))
		archiveTab.ScrollBar:SetOrientation("vertical")
		archiveTab.ScrollBar:SetPoint("TOPLEFT", archiveTab.Grid:getElement(false), "TOPRIGHT", 9, 30)
		archiveTab.ScrollBar:SetHeight(409)
		archiveTab.ScrollBar:SetWidth(15)
		archiveTab.ScrollBar:SetRange(1, 1)
		archiveTab.ScrollBar:SetEnabled(true)
		archiveTab.ScrollBar:SetVisible(true)
		archiveTab.ScrollBar.Event.ScrollbarChange = function()
			if archiveTab.ScrollBar:GetVisible() then
				local pos = archiveTab.ScrollBar:GetPosition()
				archiveTab.Grid:setPos(math.floor(pos))
			end
		end
		
	archiveTab.FilterOptions = NK.CreateFrame('nkExtText', 'FilterOptions', archiveTab,
		{	fontsize = 16, text = 'Filter Options:', 
			color = 'FFFFFF', wordwrap = false, visible = true,
			anchors = {{ from = 'TOPLEFT', object = archiveTab.Grid:getElement(), to = 'BOTTOMLEFT', x = 0, y = 5 }}
		})
		
	archiveTab.radioButtonGroup = Library.LibSimpleWidgets.RadioButtonGroup("RadioButtonGroup")
	archiveTab.radioButtonGroup.Event.RadioButtonChange = function(self)
		archiveTab.SearchRadioButtonGroup:SetSelectedIndex(1)
		EM.Archive.Populate()
	end
		
	archiveTab.ReceivedMailRadio = UI.CreateFrame("SimpleRadioButton", "ReceivedMailRadio", archiveTab)
		archiveTab.ReceivedMailRadio:SetText("Received Mail")
		archiveTab.ReceivedMailRadio:SetPoint("TOPLEFT", archiveTab.Grid:getElement(), "BOTTOMCENTER", -15, 7)
		archiveTab.ReceivedMailRadio:SetSelected(true, true)
		archiveTab.ReceivedMailRadio.Event.RadioButtonSelect = function(self)
			archiveTab.Grid.element.layoutHeader[2].label:update({text = "From"})
			archiveTab.Grid.element.layoutHeader[5].label:update({text = "Deleted"})
		end
		
	archiveTab.SentMailRadio = UI.CreateFrame("SimpleRadioButton", "SentMailRadio", archiveTab)
		archiveTab.SentMailRadio:SetText("Sent Mail")
		archiveTab.SentMailRadio:SetPoint("TOPLEFT", archiveTab.ReceivedMailRadio, "TOPRIGHT", 15, 0)
		archiveTab.SentMailRadio:SetEnabled(true)
		archiveTab.SentMailRadio.Event.RadioButtonSelect = function(self)
			archiveTab.Grid.element.layoutHeader[2].label:update({text = "To"})
			archiveTab.Grid.element.layoutHeader[5].label:update({text = "Sent"})
		end
		
	archiveTab.radioButtonGroup:AddRadioButton(archiveTab.ReceivedMailRadio)
	archiveTab.radioButtonGroup:AddRadioButton(archiveTab.SentMailRadio)
	
	archiveTab.Search = NK.CreateFrame ('nkExtTextField', 'Search', archiveTab,
		{	value = '', label = 'Search:', 
			anchors = {{from = 'TOPLEFT', object = archiveTab.FilterOptions:getElement(), to = 'BOTTOMLEFT', x = 5, y = 5 }},
			labelwidth = 40, width = 150, height = 20, fontsize = 13,
			color = { label = 'FFFFFF', border = '666666', body = '000000', focus = '999999' },
			func = function (value)
				EM.UI:SearchArchive(archiveTab, value, false)
				archiveTab.Search:setValue(value)
			end,
		})

	archiveTab.SearchCancel = NK.CreateFrame('nkExtTexture', 'SearchCancel', archiveTab,
		{	type = 'EasyMail', path = 'gfx/iconCancel.png', width = 15, height = 15,
			anchors = {{ from = 'CENTERLEFT', object = archiveTab.Search:getElement(), to = 'CENTERRIGHT', x = 5, y = 0 }},
			callBack = function()
				EM.UI:SearchArchive(archiveTab, '', true)
				archiveTab.Search:setValue('')
			end
		})
	
	archiveTab.SearchRadioButtonGroup = Library.LibSimpleWidgets.RadioButtonGroup("SearchRadioButtonGroup")
	archiveTab.SearchRadioButtonGroup.Event.RadioButtonChange = function(self) end
		
	archiveTab.NameRadio = UI.CreateFrame("SimpleRadioButton", "NameRadio", archiveTab)
		archiveTab.NameRadio:SetText("Name")
		archiveTab.NameRadio:SetPoint("TOPLEFT", archiveTab.SearchCancel:getElement(), "TOPRIGHT", 10, 0)
		archiveTab.NameRadio:SetSelected(true, true)
		archiveTab.NameRadio.Event.RadioButtonSelect = function(self)
			
		end
		
	archiveTab.SubjectRadio = UI.CreateFrame("SimpleRadioButton", "SubjectRadio", archiveTab)
		archiveTab.SubjectRadio:SetText("Subject")
		archiveTab.SubjectRadio:SetPoint("TOPLEFT", archiveTab.NameRadio, "TOPRIGHT", 7, 0)
		archiveTab.SubjectRadio:SetEnabled(true)
		archiveTab.SubjectRadio.Event.RadioButtonSelect = function(self)
			
		end
	
	archiveTab.DateRadio = UI.CreateFrame("SimpleRadioButton", "DateRadio", archiveTab)
		archiveTab.DateRadio:SetText("Date")
		archiveTab.DateRadio:SetPoint("TOPLEFT", archiveTab.SubjectRadio, "TOPRIGHT", 7, 0)
		archiveTab.DateRadio:SetEnabled(true)
		archiveTab.DateRadio.Event.RadioButtonSelect = function(self)
			
		end
		
	archiveTab.SearchRadioButtonGroup:AddRadioButton(archiveTab.NameRadio)
	archiveTab.SearchRadioButtonGroup:AddRadioButton(archiveTab.SubjectRadio)
	archiveTab.SearchRadioButtonGroup:AddRadioButton(archiveTab.DateRadio)
	
	EM.UI.Archive.Grid = archiveTab.Grid
	EM.UI.Archive.Grid.markedCount = 0
	
	EM.Archive.Populate()

end

function EM.UI:SearchArchive(frame, searchValue, reset)

	local archiveTab = EM.UI.Archive:getElement()

	local radioValue = archiveTab.SearchRadioButtonGroup:GetSelectedIndex()
	local col
	
	if radioValue == 1 then
		col = 2
	elseif radioValue == 2 then
		col = 3
	elseif radioValue == 3 then
		col = 5
	end

	frame.Search:leave()
	frame.Grid:filter (searchValue, col, reset)
	
	local gridValues = frame.Grid:getValues()
	
	if #gridValues > 20 then
		archiveTab.ScrollBar:SetRange(1, (#gridValues-19))
		archiveTab.ScrollBar:SetVisible(true)
	else
		archiveTab.ScrollBar:SetVisible(false)
	end
	
end

function EM.Archive.Populate()

	EM.Archive.List = {}
	EM.Archive.List.Recieved = {}
	EM.Archive.List.Sent = {}
	EM.Archive.List.Used = {}
	
	local archiveTab = EM.UI.Archive:getElement()
	
	if archiveTab.radioButtonGroup:GetSelectedIndex() == 1 then
		for id, details in pairs(EasyMailTable[EM.PlayerName].Inbox) do
			if details["spam"] then
				table.insert(EM.Archive.List.Recieved, { { key = id, value = 'gfx/spam-mail.png'}, { value = details["from"], color = 'ff0000'}, { value = details["subject"], color = 'ff0000'}, { value = details["attachmentCount"] or "", color = 'ff0000'}, { value = details["deleted"] or "", color = 'ff0000'} })
			elseif details["cod"] and details["read"] then
				table.insert(EM.Archive.List.Recieved, { { key = id, value = 'gfx/open-mail-cod.png'}, { value = details["from"], color = '4967ff'}, { value = "CoD | " .. details["subject"], color = '4967ff'}, { value = details["attachmentCount"] or "", color = '4967ff'}, { value = details["deleted"] or "", color = '4967ff'} })
			elseif details["cod"] and not details["read"] then
				table.insert(EM.Archive.List.Recieved, { { key = id, value = 'gfx/new-mail-cod.png'}, { value = details["from"], color = '4967ff'}, { value = "CoD | " .. details["subject"], color = '4967ff'}, { value = details["attachmentCount"] or "", color = '4967ff'}, { value = details["deleted"] or "", color = '4967ff'} })
			elseif not details["read"] then
				table.insert(EM.Archive.List.Recieved, { { key = id, value = 'gfx/new-mail.png'}, { value = details["from"], color = 'C9C9C9'}, { value = details["subject"], color = 'C9C9C9'}, { value = details["attachmentCount"] or "", color = 'C9C9C9'}, { value = details["deleted"] or "", color = 'C9C9C9'} })
			else
				table.insert(EM.Archive.List.Recieved, { { key = id, value = 'gfx/open-mail.png'}, { value = details["from"], color = 'C9C9C9'}, { value = details["subject"], color = 'C9C9C9'}, { value = details["attachmentCount"] or "", color = 'C9C9C9'}, { value = details["deleted"] or "", color = 'C9C9C9'} })
			end
		end
		--table.sort(EM.Archive.List.Recieved, function(m1, m2) return m1[5].value > m2[5].value end )
		EM.Archive.List.Used = EM.Archive.List.Recieved
	elseif archiveTab.radioButtonGroup:GetSelectedIndex() == 2 then
		for id, details in pairs(EasyMailTable[EM.PlayerName].Sent) do
			if details["attachments"] and not details["attachmentCount"] then
				details["attachmentCount"] = #details["attachments"]
			end
			if details["cod"] then
				table.insert(EM.Archive.List.Sent, { { key = id, value = 'gfx/new-mail-cod.png'}, { value = details["to"], color = '4967ff'}, { value = "CoD | " .. details["subject"], color = '4967ff'}, { value = details["attachmentCount"] or "", color = '4967ff'}, { value = details["timesent"], color = '4967ff'} })
			else
				table.insert(EM.Archive.List.Sent, { { key = id, value = 'gfx/new-mail.png'}, { value = details["to"], color = 'C9C9C9'}, { value = details["subject"], color = 'C9C9C9'}, { value = details["attachmentCount"] or "", color = 'C9C9C9'}, { value = details["timesent"], color = 'C9C9C9'} })
			end
		end
		--table.sort(EM.Archive.List.Sent, function(m1, m2) return m1[5].value > m2[5].value end )
		EM.Archive.List.Used = EM.Archive.List.Sent
	end
	
	if not archiveTab.Grid:getElement():GetVisible() then
		archiveTab.Grid:getElement():SetVisible(true)
	end
	
	archiveTab.Grid.counter = archiveTab.Grid.counter or 1
	archiveTab.Grid:fill(EM.Archive.List.Used)
	
	--archiveTab.Grid:setClickEvent(EM.UI.gridRightClick, true)
	--archiveTab.Grid:setClickEvent(EM.UI.gridLeftClick, false)

	if (#EM.Archive.List.Used) > 20 then
		archiveTab.ScrollBar:SetRange(1, (#EM.Archive.List.Used-19))
		archiveTab.ScrollBar:SetVisible(true)
	else
		archiveTab.ScrollBar:SetVisible(false)
	end

end