local toc, privateData = ...
local AddonId = toc.identifier

EM.Contacts = {}
EM.UI.Contacts = {}
EM.Contacts.Grid = {}


EM.Context.Contacts = UI.CreateContext("emContextContacts")

function EM.UI.Contacts.Create()

	Command.System.Watchdog.Quiet()
	
	local window = UI.CreateFrame("SimpleWindow", "emContactsWindow", EM.Context.Contacts)
		window:SetCloseButtonVisible(true)
		window:SetPoint("TOPLEFT", EM.UI.MailWindow, "TOPRIGHT")
		window:SetWidth(597)
		window:SetHeight(456)
		window:SetLayer(5)
		window:SetTitle("CONTACTS")
		window:SetVisible(true)
		window.Event.Close = function() end
		
	window.Categories = UI.CreateFrame("Frame", "contacts_Categories", window)
		window.Categories:SetPoint("TOPLEFT", window, "TOPLEFT", 25, 60)
		window.Categories:SetHeight(25)
		window.Categories:SetWidth(548)
		window.Categories:SetBackgroundColor(0.2,0.2,0.2,1)
		window.Categories:SetVisible(true)
		
	window.Categories.back = UI.CreateFrame("Frame", "contacts_Categories_Guild_back", window.Categories)
		window.Categories.back:SetPoint("TOPLEFT", window.Categories, "TOPLEFT", 2, 2)
		window.Categories.back:SetHeight(21)
		window.Categories.back:SetWidth(133)
		window.Categories.back:SetBackgroundColor(0,0,0,1)
		window.Categories.back:SetVisible(true)
		
	window.Categories.Text = UI.CreateFrame("Text", "contacts_Categories_Text", window.Categories.back)
		window.Categories.Text:SetPoint("TOPLEFT", window.Categories.back, "TOPLEFT", 2, 0)
		window.Categories.Text:SetHeight(25)
		window.Categories.Text:SetWidth(137)
		window.Categories.Text:SetFontColor(1,1,1,1)
		window.Categories.Text:SetFontSize(14)
		window.Categories.Text:SetText("Categories:")
		window.Categories.Text:SetVisible(true)

		
		window.Categories.Guild = UI.CreateFrame("Frame", "contacts_Categories_Guild", window.Categories)
			window.Categories.Guild:SetPoint("TOPLEFT", window.Categories, "TOPLEFT", 137, 0)
			window.Categories.Guild:SetHeight(25)
			window.Categories.Guild:SetWidth(137)
			window.Categories.Guild:SetBackgroundColor(1,1,1,0)
			window.Categories.Guild.Event.MouseIn = function() window.Categories.Guild:SetBackgroundColor(0.6,0.6,0.6,1) end
			window.Categories.Guild.Event.MouseOut = function() 
				if window.Categories.Selected == "Guild" then
					window.Categories.Guild:SetBackgroundColor(1,1,1,1)
				else
					window.Categories.Guild:SetBackgroundColor(1,1,1,0)
				end
			end
			window.Categories.Guild.Event.LeftClick = function() 
				if window.Categories.Selected == "Guild" then
					window.Categories.Selected = nil
					window.Categories.Guild:SetBackgroundColor(1,1,1,0)
					for children,info in pairs(EM.UI.ContactsWindow.Display.View:GetChildren()) do
						children:SetVisible(false)
					end
					EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(false)
					EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,1)
				else
					window.Categories.Selected = "Guild"
					window.Categories.Guild:SetBackgroundColor(1,1,1,1)
					window.Categories.Friends:SetBackgroundColor(1,1,1,0)
					window.Categories.Other:SetBackgroundColor(1,1,1,0)
					for children,info in pairs(EM.UI.ContactsWindow.Display.View:GetChildren()) do
						children:SetVisible(false)
					end
					if EM.Contacts.Grid.Guild.LastRow > 15 then
						EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(true)
						EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,EM.Contacts.Grid.Guild.LastRow-14)
					else
						EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(false)
						EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,1)
					end
					for cell,data in pairs(EM.Contacts.Grid.Guild.Cells) do
						if data.row < 16 then
							EM.Contacts.Grid.Guild.Cells[cell]:SetVisible(true)
						end
					end
				end
			end
			
			window.Categories.Guild.back = UI.CreateFrame("Frame", "contacts_Categories_Guild_back", window.Categories.Guild)
				window.Categories.Guild.back:SetPoint("TOPLEFT", window.Categories.Guild, "TOPLEFT", 2, 2)
				window.Categories.Guild.back:SetPoint("BOTTOMRIGHT", window.Categories.Guild, "BOTTOMRIGHT", -2, -2)
				window.Categories.Guild.back:SetBackgroundColor(0,0,0,1)
				window.Categories.Guild.back:SetVisible(true)
		
			window.Categories.Guild.text = UI.CreateFrame("Text", "contacts_Categories_Guild_back_text", window.Categories.Guild.back)
				window.Categories.Guild.text:SetFontColor(1,1,1,1)
				window.Categories.Guild.text:SetFontSize(14)
				window.Categories.Guild.text:SetText("Guild")
				window.Categories.Guild.text:SetVisible(true)
				window.Categories.Guild.text:SetPoint("CENTER", window.Categories.Guild.back, "CENTER", 2, 0)
			
		
		window.Categories.Friends = UI.CreateFrame("Frame", "contacts_Categories_Friends", window.Categories)
			window.Categories.Friends:SetPoint("TOPLEFT", window.Categories.Guild, "TOPRIGHT")
			window.Categories.Friends:SetHeight(25)
			window.Categories.Friends:SetWidth(137)
			window.Categories.Friends:SetBackgroundColor(1,1,1,0)
			window.Categories.Friends.Event.MouseIn = function() window.Categories.Friends:SetBackgroundColor(0.6,0.6,0.6,1) end
			window.Categories.Friends.Event.MouseOut = function() 
				if window.Categories.Selected == "Friends" then
					window.Categories.Friends:SetBackgroundColor(1,1,1,1)
				else
					window.Categories.Friends:SetBackgroundColor(1,1,1,0)
				end
			end
			window.Categories.Friends.Event.LeftClick = function() 
				if window.Categories.Selected == "Friends" then
					window.Categories.Selected = nil
					window.Categories.Friends:SetBackgroundColor(1,1,1,0)
					for children,info in pairs(EM.UI.ContactsWindow.Display.View:GetChildren()) do
						children:SetVisible(false)
					end
					EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(false)
					EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,1)
				else
					window.Categories.Selected = "Friends"
					window.Categories.Guild:SetBackgroundColor(1,1,1,0)
					window.Categories.Friends:SetBackgroundColor(1,1,1,1)
					window.Categories.Other:SetBackgroundColor(1,1,1,0)
					for children,info in pairs(EM.UI.ContactsWindow.Display.View:GetChildren()) do
						children:SetVisible(false)
					end
					if EM.Contacts.Grid.Friends.LastRow > 15 then
						EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(true)
						EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,EM.Contacts.Grid.Friends.LastRow-14)
					else
						EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(false)
						EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,1)
					end
					for cell,data in pairs(EM.Contacts.Grid.Friends.Cells) do
						if data.row < 16 then
							EM.Contacts.Grid.Friends.Cells[cell]:SetVisible(true)
						end
					end
				end
			end
			
			window.Categories.Friends.back = UI.CreateFrame("Frame", "contacts_Categories_Friends_back", window.Categories.Friends)
				window.Categories.Friends.back:SetPoint("TOPLEFT", window.Categories.Friends, "TOPLEFT", 2, 2)
				window.Categories.Friends.back:SetPoint("BOTTOMRIGHT", window.Categories.Friends, "BOTTOMRIGHT", -2, -2)
				window.Categories.Friends.back:SetBackgroundColor(0,0,0,1)
				window.Categories.Friends.back:SetVisible(true)
		
			window.Categories.Friends.text = UI.CreateFrame("Text", "contacts_Categories_Friends_back_text", window.Categories.Friends.back)
				window.Categories.Friends.text:SetFontColor(1,1,1,1)
				window.Categories.Friends.text:SetFontSize(14)
				window.Categories.Friends.text:SetText("Friends")
				window.Categories.Friends.text:SetVisible(true)
				window.Categories.Friends.text:SetPoint("CENTER", window.Categories.Friends.back, "CENTER", 2, 0)

			
		window.Categories.Other = UI.CreateFrame("Frame", "contacts_Categories_Other", window.Categories)
			window.Categories.Other:SetPoint("TOPLEFT", window.Categories.Friends, "TOPRIGHT")
			window.Categories.Other:SetHeight(25)
			window.Categories.Other:SetWidth(137)
			window.Categories.Other:SetVisible(false)
			window.Categories.Other:SetBackgroundColor(1,1,1,0)
			window.Categories.Other.Event.MouseIn = function() window.Categories.Other:SetBackgroundColor(0.6,0.6,0.6,1) end
			window.Categories.Other.Event.MouseOut = function() 
				if window.Categories.Selected == "Other" then
					window.Categories.Other:SetBackgroundColor(1,1,1,1)
				else
					window.Categories.Other:SetBackgroundColor(1,1,1,0)
				end
			end
			window.Categories.Other.Event.LeftClick = function() 
				if window.Categories.Selected == "Other" then
					window.Categories.Selected = nil
					window.Categories.Other:SetBackgroundColor(1,1,1,0)
					for children,info in pairs(EM.UI.ContactsWindow.Display.View:GetChildren()) do
						children:SetVisible(false)
					end
					EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(false)
					EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,1)
				else
					window.Categories.Selected = "Other"
					window.Categories.Guild:SetBackgroundColor(1,1,1,0)
					window.Categories.Friends:SetBackgroundColor(1,1,1,0)
					window.Categories.Other:SetBackgroundColor(1,1,1,1)
					for children,info in pairs(EM.UI.ContactsWindow.Display.View:GetChildren()) do
						children:SetVisible(false)
					end
					if EM.Contacts.Grid.Other.LastRow > 15 then
						EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(true)
						EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,EM.Contacts.Grid.Other.LastRow-14)
					else
						EM.UI.ContactsWindow.Display.Scrollbar:SetEnabled(false)
						EM.UI.ContactsWindow.Display.Scrollbar:SetRange(1,1)
					end
					for cell,data in pairs(EM.Contacts.Grid.Other.Cells) do
						if data.row < 16 then
							EM.Contacts.Grid.Other.Cells[cell]:SetVisible(true)
						end
					end
				end
			end
			
			window.Categories.Other.back = UI.CreateFrame("Frame", "contacts_Categories_Other_back", window.Categories.Other)
				window.Categories.Other.back:SetPoint("TOPLEFT", window.Categories.Other, "TOPLEFT", 2, 2)
				window.Categories.Other.back:SetPoint("BOTTOMRIGHT", window.Categories.Other, "BOTTOMRIGHT", -2, -2)
				window.Categories.Other.back:SetBackgroundColor(0,0,0,1)
				window.Categories.Other.back:SetVisible(true)
		
			window.Categories.Other.text = UI.CreateFrame("Text", "contacts_Categories_Other_back_text", window.Categories.Other.back)
				window.Categories.Other.text:SetFontColor(1,1,1,1)
				window.Categories.Other.text:SetFontSize(14)
				window.Categories.Other.text:SetText("Other")
				window.Categories.Other.text:SetVisible(true)
				window.Categories.Other.text:SetPoint("CENTER", window.Categories.Other.back, "CENTER", 2, 0)
				window.Categories.Other.text:SetWidth(window.Categories.Other.text:GetWidth()+1)
				
				
	window.Display = UI.CreateFrame("Frame", "contacts_Display", window)
		window.Display:SetPoint("TOPLEFT", window.Categories, "BOTTOMLEFT", 0, 5)
		window.Display:SetWidth(528)
		window.Display:SetHeight(320)
		window.Display:SetBackgroundColor(0.2,0.2,0.2,1)
		window.Display:SetVisible(true)
		window.Display:SetLayer(10)
		window.Display.Event.WheelForward = function()
			window.Display.Scrollbar:NudgeUp()
		end
		window.Display.Event.WheelBack = function()
			window.Display.Scrollbar:NudgeDown()
		end
		
		window.Display.View = UI.CreateFrame("Frame", "contacts_Display_ScrollBar_view", window.Display)
			window.Display.View:SetPoint("TOPLEFT", window.Display, "TOPLEFT")
			window.Display.View:SetHeight(320)
			window.Display.View:SetWidth(528)
		
		window.Display.Scrollbar = UI.CreateFrame("RiftScrollbar", "contacts_Display_ScrollBar", window.Display)
			window.Display.Scrollbar:SetPoint("TOPLEFT", window.Display, "TOPRIGHT", 5, 0)
			window.Display.Scrollbar:SetPoint("BOTTOMLEFT", window.Display, "BOTTOMRIGHT", 5, 0)
			window.Display.Scrollbar:SetThickness(15)
			window.Display.Scrollbar:SetRange(1,1)
			window.Display.Scrollbar:SetVisible(true)
			window.Display.Scrollbar:SetEnabled(false)
			window.Display.Scrollbar.Event.WheelForward = function()
				window.Display.Scrollbar:NudgeUp()
			end
			window.Display.Scrollbar.Event.WheelBack = function()
				window.Display.Scrollbar:NudgeDown()
			end
			window.Display.Scrollbar.Event.ScrollbarChange = function()
				local pos = math.floor(window.Display.Scrollbar:GetPosition())-1
				EM.UI.ContactsWindow.Display.View:SetPoint("TOPLEFT", EM.UI.ContactsWindow.Display, "TOPLEFT", 0, -(pos*20))
				for cell,data in pairs(EM.UI.ContactsWindow.Display.View:GetChildren()) do
					if cell.category == EM.UI.ContactsWindow.Categories.Selected then
						if cell.row < pos or cell.row > pos+15 then
							EM.Contacts.Grid[EM.UI.ContactsWindow.Categories.Selected].Cells[cell.name]:SetVisible(false)
						else
							EM.Contacts.Grid[EM.UI.ContactsWindow.Categories.Selected].Cells[cell.name]:SetVisible(true)
						end
					end
				end
			end
			
		
	window.Text = UI.CreateFrame("Text", "contacts_Text", window)
		window.Text:SetPoint("TOPLEFT", window.Display, "BOTTOMLEFT", 5, 5)
		window.Text:SetFontColor(1,1,1,1)
		window.Text:SetFontSize(13)
		window.Text:SetText("Left click a contact to select.")--  Right click a contact to add them to Auto Complete.")
		window.Text:SetVisible(true)
	
	EM.UI.ContactsWindow = window
	
	EM.UI.Contacts.Populate()
	
end

function EM.UI.Contacts.Populate()

	EM.Contacts.List = {}
	EM.Contacts.List.Guild = {}
	EM.Contacts.List.Friends = {}
	EM.Contacts.Grid.Guild = {}
	EM.Contacts.Grid.Guild.Selected = {}
	EM.Contacts.Grid.Guild.Cells = {}
	EM.Contacts.Grid.Guild.LastRow = 0
	EM.Contacts.Grid.Guild.LastColumn = 0
	EM.Contacts.Grid.Friends = {}
	EM.Contacts.Grid.Friends.Selected = {}
	EM.Contacts.Grid.Friends.Cells = {}
	EM.Contacts.Grid.Friends.LastRow = 0
	EM.Contacts.Grid.Friends.LastColumn = 0
	EM.Contacts.Grid.Other = {}
	EM.Contacts.Grid.Other.Selected = {}
	EM.Contacts.Grid.Other.Cells = {}
	EM.Contacts.Grid.Other.LastRow = 0
	EM.Contacts.Grid.Other.LastColumn = 0

	if EM.UI.ContactsWindow then
		if Inspect.Unit.Detail("player").guild then
			for name,status in pairs(Inspect.Guild.Roster.List()) do
				table.insert(EM.Contacts.List.Guild, name)
				table.sort(EM.Contacts.List.Guild, function(a,b) return a<b end)
			end
			for slot,name in ipairs(EM.Contacts.List.Guild) do EM.UI.Contacts.addCell(name, 'Guild') end
		end
	
		for name,status in pairs(Inspect.Social.Friend.List()) do
			table.insert(EM.Contacts.List.Friends, name)
			table.sort(EM.Contacts.List.Friends, function(a,b) return a<b end)
		end
	
		for slot,name in ipairs(EM.Contacts.List.Friends) do EM.UI.Contacts.addCell(name, 'Friends') end
	end

end

function EM.UI.Contacts.addCell(name,category)

	local cell = UI.CreateFrame("Frame", "contacts_Display_" .. category .. "_" .. name, EM.UI.ContactsWindow.Display.View)
		cell:SetPoint("TOPLEFT", EM.UI.ContactsWindow.Display.View, "TOPLEFT", EM.Contacts.Grid[category].LastColumn*132, EM.Contacts.Grid[category].LastRow*20)
		cell.row = EM.Contacts.Grid[category].LastRow
		cell.column = EM.Contacts.Grid[category].LastColumn
		cell.name = name
		cell.category = category
		cell:SetHeight(20)
		cell:SetWidth(132)
		cell:SetBackgroundColor(1,1,1,0)
		cell:SetVisible(false)
		cell:SetLayer(15)
		cell.Event.MouseIn = function() cell:SetBackgroundColor(0.6,0.6,0.6,1) end
		cell.Event.MouseOut = function() 
			--if EM.Contacts.Grid.Selected[name] then
				--cell:SetBackgroundColor(1,1,1,1)
			--else
				cell:SetBackgroundColor(1,1,1,0)
			--end
		end
		function cell.Event.LeftClick()
			if EM.UI.Send:getElement().ToField:getValue(true) == nil then
				EM.UI.Send:getElement().ToField:setValue(name)
			else
				local current = EM.UI.Send:getElement().ToField:getValue(true)
				EM.UI.Send:getElement().ToField:setValue(current .. "; " .. name)
			end
		end
		--[[function cell.Event.RightClick()
			if EM.Contacts.Grid.Selected[name] then
				cell:SetBackgroundColor(1,1,1,0)
				EM.Contacts.Grid.Selected[name] = false
			else
				table.insert(EM.Contacts.Grid.Selected, {name = true})
				cell:SetBackgroundColor(1,1,1,1)
			end
		end]]--
			
	cell.back = UI.CreateFrame("Frame", "contacts_Display_" .. category .. "_" .. name .. "_back", cell)
		cell.back:SetPoint("TOPLEFT", cell, "TOPLEFT", 2, 2)
		cell.back:SetPoint("BOTTOMRIGHT", cell, "BOTTOMRIGHT", -2, -2)
		cell.back:SetBackgroundColor(0,0,0,1)
		cell.back:SetVisible(true)
		cell.back:SetLayer(20)
		
	cell.text = UI.CreateFrame("Text", "contacts_Display_" .. category .. "_" .. name .. "_text", cell.back)
		cell.text:SetText(name)
		cell.text:SetFontSize(14)
		if cell.text:GetWidth() > 127 then
			cell.text:SetPoint("CENTERLEFT", cell.back, "CENTERLEFT")
			cell.text:SetWidth(127)
		else
			cell.text:SetPoint("CENTER", cell.back, "CENTER")
			cell.text:SetWidth(cell.text:GetWidth()+1)
		end
		cell.text:SetFontColor(1,1,1,1)
		cell.text:SetVisible(true)
		cell.text:SetLayer(30)
	
	EM.Contacts.Grid[category].Cells[name] = cell
			
	if EM.Contacts.Grid[category].LastColumn < 3 then
		EM.Contacts.Grid[category].LastColumn = EM.Contacts.Grid[category].LastColumn + 1
	else
		EM.Contacts.Grid[category].LastColumn = 0
		EM.Contacts.Grid[category].LastRow = EM.Contacts.Grid[category].LastRow + 1
	end
	
end

table.insert(Event.Guild.Roster.Add, 		{ EM.UI.Contacts.Populate, AddonId, AddonId .. "_GuildAdd" })
table.insert(Event.Guild.Roster.Remove, 	{ EM.UI.Contacts.Populate, AddonId, AddonId .. "_GuildRemove" })
table.insert(Event.Social.Friend, 			{ EM.UI.Contacts.Populate, AddonId, AddonId .. "_FriendChange" })
