local toc, privateData = ...
local AddonId = toc.identifier

EM.UI.Inbox = {}
EM.Temp.PopupTest = false

EM.Event.Trigger.TakeAttachment, EM.Event.TakeAttachment = Utility.Event.Create(AddonId, "TakeAttachment")
EM.Event.Trigger.OpenMessage, EM.Event.OpenMessage = Utility.Event.Create(AddonId, "OpenMessage")

function EM.UI.SetupInboxTab()
	
	local inboxTab = EM.UI.Inbox:getElement()

	inboxTab.Grid = NK.CreateFrame('nkExtGrid', 'MessageGrid', inboxTab,
		{	fontsize = 13, wheelFunc = function(counter) inboxTab.ScrollBar:SetPosition(counter) end,
			color = {	headerBody = '', headerLabel = 'FFFFFF',
						label = 'FFFFFF', border = '000000', body = '222222', 
						bodyhighlight = 'FFFFFF', labelhighlight = '000000' },
			anchors = {	{ from = 'TOPLEFT', object = inboxTab, to = 'TOPLEFT', x = 10, y = 0 }}
		})
		
		local cols = {	{	align = 'center', texture = true, type = 'EasyMail', path = 'gfx/new-mail.png',
							width = 23, textureWidth = 17, textureHeight = 17 },
						{	align = 'left', header = 'From', width = 80 },
						{	align = 'left', header = 'Subject', width = 210 },
						{	align = 'center', sortable = false, width = 20 },
						{	align = 'left', header = 'Expiration', width = 61}}
						
		inboxTab.Grid:layout( cols, 20, {headerHeight = 35})
		
	inboxTab.ScrollBar = UI.CreateFrame("RiftScrollbar", "inboxScrollBar", inboxTab.Grid:getElement(false))
		inboxTab.ScrollBar:SetOrientation("vertical")
		inboxTab.ScrollBar:SetPoint("TOPLEFT", inboxTab.Grid:getElement(false), "TOPRIGHT", 9, 30)
		inboxTab.ScrollBar:SetHeight(409)
		inboxTab.ScrollBar:SetWidth(15)
		inboxTab.ScrollBar:SetRange(1, 1)
		inboxTab.ScrollBar:SetEnabled(true)
		inboxTab.ScrollBar:SetVisible(true)
		inboxTab.ScrollBar.Event.ScrollbarChange = function()
			if inboxTab.ScrollBar:GetVisible() then
				local pos = inboxTab.ScrollBar:GetPosition()
				inboxTab.Grid:setPos(math.floor(pos))
			end
		end
	
	inboxTab.btnDeleteAll = UI.CreateFrame("RiftButton", "inboxDeleteAll", inboxTab)
		inboxTab.btnDeleteAll:SetText("Delete All")
		inboxTab.btnDeleteAll:SetPoint("BOTTOMRIGHT", inboxTab, "BOTTOMCENTER", -5, 2)
		inboxTab.btnDeleteAll:SetEnabled(false)
		
	inboxTab.btnTakeAll = UI.CreateFrame("RiftButton", "inboxTakeAll", inboxTab)
		inboxTab.btnTakeAll:SetText("Take All")
		inboxTab.btnTakeAll:SetPoint("BOTTOMLEFT", inboxTab, "BOTTOMCENTER", 5, 2)
		inboxTab.btnTakeAll:SetEnabled(false)
		
	inboxTab.btnTakeSelected = UI.CreateFrame("RiftButton", "inboxTakeSelected", inboxTab)
		inboxTab.btnTakeSelected:SetText("Take Selected")
		inboxTab.btnTakeSelected:SetPoint("BOTTOMLEFT", inboxTab.btnTakeAll, "TOPCENTER", 5, 6)
		inboxTab.btnTakeSelected:SetEnabled(false)
		
	inboxTab.btnDeleteSelected = UI.CreateFrame("RiftButton", "inboxDeleteSelected", inboxTab)
		inboxTab.btnDeleteSelected:SetText("Delete Selected")
		inboxTab.btnDeleteSelected:SetPoint("BOTTOMRIGHT", inboxTab.btnDeleteAll, "TOPCENTER", -5, 6)
		inboxTab.btnDeleteSelected:SetEnabled(false)
	
	EM.UI.Inbox.Grid = inboxTab.Grid
	EM.UI.Inbox.Grid.markedCount = 0
		
	function inboxTab.btnDeleteSelected.Event:LeftPress()
	local tempDeleteList = {}
		if EM.Temp.PopupTest then
			for row, data in ipairs(EM.UI.Inbox.Grid.markedRows) do
				if data.status == 'true' then
					if data.visibility == 'true' then
						EM.UI.Inbox.Grid:rowMark(data.location, false)
					else
						data.status = 'false'
					end
					EM.UI.Inbox.Grid.markedCount = EM.UI.Inbox.Grid.markedCount - 1
					if EM.UI.Inbox.Grid.counter > 1 then
						EM.UI.Inbox.Grid.counter = EM.UI.Inbox.Grid.counter - 1
					end
					key = EM.UI.Inbox.Grid.values[data.row][1].key
					EasyMailTable[EM.PlayerName].Inbox[key].deleted = os.date("%x %X", Inspect.Time.Server())
					table.insert(tempDeleteList, key)
				end
			end
			for idx, key in ipairs(tempDeleteList) do
				Command.Mail.Delete(key)
			end
			inboxTab.Grid:fill()
			EM.Temp.PopupTest = false
		else
			EM.UI.Popup(2, "Really Delete the Selected messages?", EM.UI.Inbox.element.btnDeleteSelected.Event.LeftPress)
		end
		inboxTab.btnTakeSelected:SetEnabled(false)
		inboxTab.btnDeleteSelected:SetEnabled(false)
	end

	function inboxTab.btnDeleteAll.Event:LeftPress()
		if EM.Temp.PopupTest then
			for row, data in ipairs(EM.UI.Inbox.Grid.markedRows) do
				if data.status == 'true' then
					if data.visibility == 'true' then
						EM.UI.Inbox.Grid:rowMark(data.location, false)
					else
						data.status = 'false'
					end
					EM.UI.Inbox.Grid.markedCount = EM.UI.Inbox.Grid.markedCount - 1
				end
				if EM.UI.Inbox.Grid.counter > 1 then
					EM.UI.Inbox.Grid.counter = EM.UI.Inbox.Grid.counter - 1
				end
				key = EM.UI.Inbox.Grid.values[data.row][1].key
				EasyMailTable[EM.PlayerName].Inbox[key].deleted = os.date("%x %X", Inspect.Time.Server())
				Command.Mail.Delete(key)
			end
			inboxTab.Grid:fill()
			EM.Temp.PopupTest = false
		else
			EM.UI.Popup(2, "Really Delete all messages?", EM.UI.Inbox.element.btnDeleteAll.Event.LeftPress)
		end
		if EM.UI.Inbox.Grid.markedCount == 0 then
			inboxTab.btnTakeSelected:SetEnabled(false)
			inboxTab.btnDeleteSelected:SetEnabled(false)
		end
	end

	function inboxTab.btnTakeSelected.Event:LeftPress()
		local tempSelected = {}
		for row, data in ipairs(EM.UI.Inbox.Grid.markedRows) do
			local id = EM.UI.Inbox.Grid.values[data.row][1].key
			if data.status == 'true' then
				if data.visibility == 'true' then
					EM.UI.Inbox.Grid:rowMark(data.row, false)
				else
					data.status = 'false'
				end
				EM.UI.Inbox.Grid.markedCount = EM.UI.Inbox.Grid.markedCount - 1
				if EM.UI.Inbox.Grid.counter > 1 then
					EM.UI.Inbox.Grid.counter = EM.UI.Inbox.Grid.counter - 1
				end
				table.insert(tempSelected, id)
			end
		end
		EM.Event.Trigger.OpenMessage(tempSelected)
		inboxTab.btnTakeSelected:SetEnabled(false)
		inboxTab.btnDeleteSelected:SetEnabled(false)
	end

	function inboxTab.btnTakeAll.Event:LeftPress()
		local tempAll = {}
		for row, data in ipairs(EM.UI.Inbox.Grid.markedRows) do
			local id = EM.UI.Inbox.Grid.values[data.row][1].key
			if data.status == 'true' then
				if data.visibility == 'true' then
					EM.UI.Inbox.Grid:rowMark(data.row, false)
				else
					data.status = 'false'
				end
				EM.UI.Inbox.Grid.markedCount = EM.UI.Inbox.Grid.markedCount - 1
			end
			if EM.UI.Inbox.Grid.counter > 1 then
				EM.UI.Inbox.Grid.counter = EM.UI.Inbox.Grid.counter - 1
			end
			table.insert(tempAll, id)
		end
		EM.Event.Trigger.OpenMessage(tempAll)
		if EM.UI.Inbox.Grid.markedCount == 0 then
			inboxTab.btnTakeSelected:SetEnabled(false)
			inboxTab.btnDeleteSelected:SetEnabled(false)
		end
	end
	
	EM.UI.Created = true
	EM.Event.Trigger.UICreated(Inspect.Mail.List())
	
end

function EM.UI.Popup(numbtn, message, callFunc)
	
	local popupWindow = {}
	local popup = {}
	
	if EM.UI.PopupWindow then
		EM.UI.PopupWindow:SetVisible(true)
		EM.UI.PopupWindow.messagetxt:SetText(message)
	else
		popupWindow = NK.CreateFrame('nkExtTexture', 'emPopupWindow', EM.Context.Main,
			{	type = 'EasyMail', path = 'gfx/popup.png', layer = 90,
				anchors = {{ from = 'CENTER', object = UIParent, to = 'CENTER' }}
			})
		
		popup = popupWindow:getElement()
			
		popup.okbtn = UI.CreateFrame("RiftButton", "popupOK", popup)
			popup.okbtn:SetText("OK")
			popup.okbtn:SetPoint("BOTTOMRIGHT", popup, "BOTTOMCENTER", 5, -15)
			popup.okbtn:SetEnabled(true)
		
		popup.cancelbtn = UI.CreateFrame("RiftButton", "popupCancel", popup)
			popup.cancelbtn:SetText("CANCEL")
			popup.cancelbtn:SetPoint("BOTTOMLEFT", popup, "BOTTOMCENTER", -2, -15)
			popup.cancelbtn:SetEnabled(true)
			
		popup.messagetxt = UI.CreateFrame("Text", "popupMessage", popup)
			popup.messagetxt:SetText(message)
			popup.messagetxt:SetFontSize(22)
			popup.messagetxt:SetPoint("TOPCENTER", popup, "TOPCENTER", 0, 10)
			popup.messagetxt:SetFontColor(0.85,0.80,0.62,1)
			popup.messagetxt:SetVisible(true)
		
		EM.UI.PopupWindow = popupWindow:getElement()
	end
	
	if numbtn == 1 then
		EM.UI.PopupWindow.okbtn:ClearAll()
		EM.UI.PopupWindow.okbtn:SetPoint("BOTTOMCENTER", EM.UI.PopupWindow, "BOTTOMCENTER", 0, -15)
		EM.UI.PopupWindow.cancelbtn:SetEnabled(false)
		EM.UI.PopupWindow.cancelbtn:SetVisible(false)
	end
	
	function EM.UI.PopupWindow.okbtn.Event:LeftPress()
		EM.UI.PopupWindow:SetVisible(false)
		if callFunc then
			EM.UI.Callback.Popup(callFunc)
		else
			return
		end
	end
	
	function EM.UI.PopupWindow.cancelbtn.Event:LeftPress()
		EM.UI.PopupWindow:SetVisible(false)
	end
end

function EM.UI.Callback.Popup(callFunc)
	EM.Temp.PopupTest = true
	callFunc()
end

function EM.UI.Inbox.OpenMessage(list)
	if list then
		EM.Temp.list = list
	end
	if EM.Temp.list then
		local key = EM.Temp.list[1] or nil
		if key then
			Command.Mail.Open(key, EM.UI.Callback.Open)
		else
			EM.UI.Inbox:getElement().Grid:fill()
		end
	end
end

function EM.UI.Callback.Open(status, message)
	if not status then
		for id,t in pairs(EM.Mail.List.Original) do
			EM.Temp.Opened = EM.Messages[id]
			if not EM.Temp.Opened then return end
			if EM.Temp.Opened.cod then
				EasyMailTable[EM.PlayerName].Inbox[id].paidCoD = EM.Temp.Opened.cod
				Command.Mail.Pay(id, EM.UI.Callback.Pay)
			elseif EM.Temp.Opened.attachments ~= nil then
				EM.Event.Trigger.TakeAttachment()
			else
				table.remove(EM.Temp.list, 1)
				EM.Event.Trigger.OpenMessage()
			end
		end
	end
end

function EM.UI.Callback.Pay(status, message)
	if not status then
		EM.Event.Trigger.OpenMessage()
	end
end

function EM.UI.Inbox.TakeAttachment()
	local itemIDs = EM.Temp.Opened.attachments or nil
	if itemIDs and next(itemIDs) ~= nil then
		Command.Mail.Take(EM.Temp.Opened.id, itemIDs, EM.UI.Callback.Take)
	else
		table.remove(EM.Temp.list, 1)
		EM.Event.Trigger.OpenMessage()
	end
end

function EM.UI.Callback.Take(status, message)
	if not status then
		EM.Temp.Opened = EM.Messages[EM.Temp.Opened.id]
		EM.Event.Trigger.TakeAttachment()
	end
end

function EM.Mail.Populate(id,status)

	EM.Mail.List.Grid = {}
	local inboxTab = EM.UI.Inbox:getElement()
	
	for id, details in pairs(EM.Messages) do
		if details["spam"] then
			table.insert(EM.Mail.List.Grid, { { key = id, value = 'gfx/spam-mail.png'}, { value = details["from"], color = 'ff0000'}, { value = details["subject"], color = 'ff0000'}, { value = details["attachmentCount"] or "", color = 'ff0000'}, { value = details["expire"], color = 'ff0000'} })
		elseif details["cod"] and not details["read"] then
			table.insert(EM.Mail.List.Grid, { { key = id, value = 'gfx/new-mail-cod.png'}, { value = details["from"], color = '4967ff'}, { value = "CoD | " .. details["subject"], color = '4967ff'}, { value = details["attachmentCount"] or "", color = '4967ff'}, { value = details["expire"], color = '4967ff'} })
		elseif details["cod"] then
			table.insert(EM.Mail.List.Grid, { { key = id, value = 'gfx/open-mail-cod.png'}, { value = details["from"], color = '4967ff'}, { value = "CoD | " .. details["subject"], color = '4967ff'}, { value = details["attachmentCount"] or "", color = '4967ff'}, { value = details["expire"], color = '4967ff'} })
		elseif details["read"] then
			table.insert(EM.Mail.List.Grid, { { key = id, value = 'gfx/open-mail.png'}, { value = details["from"], color = 'C9C9C9'}, { value = details["subject"], color = 'C9C9C9'}, { value = details["attachmentCount"] or "", color = 'C9C9C9'}, { value = details["expire"], color = 'C9C9C9'} })
		else
			table.insert(EM.Mail.List.Grid, { { key = id, value = 'gfx/new-mail.png'}, { value = details["from"], color = '1ec526'}, { value = details["subject"], color = '1ec526'}, { value = details["attachmentCount"] or "", color = '1ec526'}, { value = details["expire"], color = '1ec526'} })
		end
	end
	
	if next(EM.Mail.List.Grid) == nil then
		inboxTab.Grid:getElement():SetVisible(false)
		inboxTab.btnTakeAll:SetEnabled(false)
		inboxTab.btnDeleteAll:SetEnabled(false)
		return
	end
	
	inboxTab.btnTakeAll:SetEnabled(true)
	inboxTab.btnDeleteAll:SetEnabled(true)
	
	table.sort(EM.Mail.List.Grid, function(m1, m2) return m1[5].value > m2[5].value end )
	
	if not inboxTab.Grid:getElement():GetVisible() then
		inboxTab.Grid:getElement():SetVisible(true)
	end
	
	inboxTab.Grid.counter = inboxTab.Grid.counter or 1
	inboxTab.Grid:fill(EM.Mail.List.Grid)
	
	inboxTab.Grid:setClickEvent(EM.UI.gridRightClick, true)
	inboxTab.Grid:setClickEvent(EM.UI.gridLeftClick, false)

	if (#EM.Mail.List.Grid) > 20 then
		inboxTab.ScrollBar:SetRange(1, (#EM.Mail.List.Grid-19))
		inboxTab.ScrollBar:SetVisible(true)
	else
		inboxTab.ScrollBar:SetVisible(false)
	end

end

function EM.UI.gridRightClick(row)

	local inboxTab = EM.UI.Inbox:getElement()
	
	if not EM.UI.Inbox.Grid.values[row] then return end
	local realRow = (row - 1 + EM.UI.Inbox.Grid.counter)
	if EM.UI.Inbox.Grid.markedRows[realRow].status == 'true' then
		EM.UI.Inbox.Grid:rowMark(realRow, false)
		EM.UI.Inbox.Grid.markedCount = EM.UI.Inbox.Grid.markedCount - 1
		if EM.UI.Inbox.Grid.markedCount == 0 then
			inboxTab.btnTakeSelected:SetEnabled(false)
			inboxTab.btnDeleteSelected:SetEnabled(false)
		end
	else
		EM.UI.Inbox.Grid:rowMark(realRow, true)
		inboxTab.btnTakeSelected:SetEnabled(true)
		inboxTab.btnDeleteSelected:SetEnabled(true)
		EM.UI.Inbox.Grid.markedCount = EM.UI.Inbox.Grid.markedCount + 1
	end
end

function EM.UI.gridLeftClick(row)
	if not EM.UI.Inbox.Grid.values[row] then return end
	if next(EM.UI.Inbox.Grid.values) ~= nil then
		local valuesRow = (row - 1) + EM.UI.Inbox.Grid.counter
		local messageId = EM.UI.Inbox.Grid.values[valuesRow][1].key
		Command.Mail.Open(messageId)
		EM.UI.Inbox.Grid.openRow = row
	end
end


table.insert(EM.Event.RefreshMail,			{ EM.Mail.Populate, AddonId, AddonId .. "_RefreshMail" })
table.insert(EM.Event.TakeAttachment, 		{ EM.UI.Inbox.TakeAttachment, AddonId, AddonId .. "_TakeAttachment" })
table.insert(EM.Event.OpenMessage, 			{ EM.UI.Inbox.OpenMessage, AddonId, AddonId .. "_OpenMessage" })
