local toc, privateData = ...
local AddonId = toc.identifier

EM.UI.Inventory = {}
EM.UI.Inventory.Bags = {}

EM.Context.Inventory = UI.CreateContext("emInventoryContext")
EM.Context.Inventory:SetStrata("tutorial")

local tableAdd = table.insert

function UI.Native.BagInventory1.Event:Loaded()
	if EM.UI.MailWindow:GetVisible() and EM.UI.Tabs and EM.UI.Tabs:getActivePane() == 2 then
		if EM.UI.Inventory.Bags[1] and not EM.UI.Inventory.Bags[1]:GetVisible() and UI.Native.BagInventory1:GetLoaded() then
			EM.UI.Inventory.Bags[1]:SetVisible(true)
		elseif EM.UI.Inventory.Bags[1] and EM.UI.Inventory.Bags[1]:GetVisible() and not UI.Native.BagInventory1:GetLoaded() then
			EM.UI.Inventory.Bags[1]:SetVisible(false)
		else
			tableAdd(EM.UI.Inventory.Bags, 1)
			local bagWindow = UI.CreateFrame("Frame", "emInventoryBag1", EM.Context.Inventory)
				bagWindow:SetPoint("TOPLEFT", UI.Native.BagInventory1, 0.01688, 0)
				bagWindow:SetPoint("BOTTOMRIGHT", UI.Native.BagInventory1, 0.96625, 0.975)
				bagWindow:SetVisible(true)
				
			local slots = Inspect.Item.Detail("sibg.001").slots
			local slotPosition = {col = 0, row = 0}
			for i=1, slots, 1 do
				bagWindow[i] = UI.CreateFrame("Frame", "emInventoryBag1_Slot" .. i, bagWindow)
					if i==1 then
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow, "TOPLEFT", 15, 33)
					else
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow[1], "TOPLEFT", slotPosition.col*52, slotPosition.row*52)
					end
					bagWindow[i]:SetHeight(50)
					bagWindow[i]:SetWidth(50)
					bagWindow[i]:SetBackgroundColor(0,0,0,0)
					bagWindow[i]:SetMouseMasking("limited")
					bagWindow[i]:SetVisible(true)
					
				if slotPosition.col < 3 then
					slotPosition.col = slotPosition.col + 1
				else
					slotPosition.col = 0
					slotPosition.row = slotPosition.row + 1
				end
				if i < 10 then
					bagWindow[i].name = "si01.00" .. i
				else
					bagWindow[i].name = "si01.0" .. i
				end
				local item = Inspect.Item.Detail(bagWindow[i].name)
				bagWindow[i].Event.RightClick = function()
					if bagWindow[i].attached then return end
					if item.bound == nil then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {1,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					elseif item.bind == "account" then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {1,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					end
					if #EM.UI.Send.Attachments == 0 then return end
					EM.UI.Send.AttachGrid.counter = EM.UI.Send.AttachGrid.counter or 1
					EM.UI.Send.AttachGrid:fill(EM.UI.Send.Attachments)
					if #EM.UI.Send.Attachments > 4 then
						EM.UI.Send:getElement().AttachScrollBar:SetRange(1, (#EM.UI.Send.Attachments-3))
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(true)
					else
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(false)
					end
					bagWindow[i].attached = true
				end
				
				bagWindow[i].Event.MouseIn = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0.18,0.36,0.41,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0.36,0.65,0.72,0.4)
					end
					Command.Tooltip(item.id)
				end
				
				bagWindow[i].Event.MouseOut = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0,0,0,0)
					end
					Command.Tooltip(nil)
				end
			end
			
			EM.UI.Inventory.Bags[1] = bagWindow
			
		end
	end
end

function UI.Native.BagInventory2.Event:Loaded()
	if EM.UI.Tabs and EM.UI.Tabs:getActivePane() == 2 then
		if EM.UI.Inventory.Bags[2] and not EM.UI.Inventory.Bags[2]:GetVisible() and UI.Native.BagInventory2:GetLoaded() then
			EM.UI.Inventory.Bags[2]:SetVisible(true)
		elseif EM.UI.Inventory.Bags[2] and EM.UI.Inventory.Bags[2]:GetVisible() and not UI.Native.BagInventory2:GetLoaded() then
			EM.UI.Inventory.Bags[2]:SetVisible(false)
		else
			tableAdd(EM.UI.Inventory.Bags, 2)
			local bagWindow = UI.CreateFrame("Frame", "emInventoryBag2", EM.Context.Inventory)
				bagWindow:SetPoint("TOPLEFT", UI.Native.BagInventory2, 0.01688, 0)
				bagWindow:SetPoint("BOTTOMRIGHT", UI.Native.BagInventory2, 0.96625, 0.975)
				bagWindow:SetVisible(true)
			
			local slots = Inspect.Item.Detail("sibg.002").slots
			local slotPosition = {col = 0, row = 0}
			for i=1, slots, 1 do
				bagWindow[i] = UI.CreateFrame("Frame", "emInventoryBag2_Slot" .. i, bagWindow)
					if i==1 then
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow, "TOPLEFT", 15, 33)
					else
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow[1], "TOPLEFT", slotPosition.col*52, slotPosition.row*52)
					end
					bagWindow[i]:SetHeight(50)
					bagWindow[i]:SetWidth(50)
					bagWindow[i]:SetBackgroundColor(0,0,0,0)
					bagWindow[i]:SetMouseMasking("limited")
					bagWindow[i]:SetVisible(true)
					
				if slotPosition.col < 3 then
					slotPosition.col = slotPosition.col + 1
				else
					slotPosition.col = 0
					slotPosition.row = slotPosition.row + 1
				end
				if i < 10 then
					bagWindow[i].name = "si02.00" .. i
				else
					bagWindow[i].name = "si02.0" .. i
				end
				local item = Inspect.Item.Detail(bagWindow[i].name)
				bagWindow[i].Event.RightClick = function()
					if bagWindow[i].attached then return end
					if item.bound == nil then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {2,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					elseif item.bind == "account" then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {2,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					end
					if #EM.UI.Send.Attachments == 0 then return end
					EM.UI.Send.AttachGrid.counter = EM.UI.Send.AttachGrid.counter or 1
					EM.UI.Send.AttachGrid:fill(EM.UI.Send.Attachments)
					if #EM.UI.Send.Attachments > 4 then
						EM.UI.Send:getElement().AttachScrollBar:SetRange(1, (#EM.UI.Send.Attachments-3))
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(true)
					else
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(false)
					end
					bagWindow[i].attached = true
				end
				
				bagWindow[i].Event.MouseIn = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0.18,0.36,0.41,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0.36,0.65,0.72,0.4)
					end
					Command.Tooltip(item.id)
				end
				
				bagWindow[i].Event.MouseOut = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0,0,0,0)
					end
					Command.Tooltip(nil)
				end
			end
			
			EM.UI.Inventory.Bags[2] = bagWindow

		end
	end
end

function UI.Native.BagInventory3.Event:Loaded()
	if EM.UI.Tabs and EM.UI.Tabs:getActivePane() == 2 then
		if EM.UI.Inventory.Bags[3] and not EM.UI.Inventory.Bags[3]:GetVisible() and UI.Native.BagInventory3:GetLoaded() then
			EM.UI.Inventory.Bags[3]:SetVisible(true)
		elseif EM.UI.Inventory.Bags[3] and EM.UI.Inventory.Bags[3]:GetVisible() and not UI.Native.BagInventory3:GetLoaded() then
			EM.UI.Inventory.Bags[3]:SetVisible(false)
		else
			tableAdd(EM.UI.Inventory.Bags, 3)
			local bagWindow = UI.CreateFrame("Frame", "emInventoryBag3", EM.Context.Inventory)
				bagWindow:SetPoint("TOPLEFT", UI.Native.BagInventory3, 0.01688, 0)
				bagWindow:SetPoint("BOTTOMRIGHT", UI.Native.BagInventory3, 0.96625, 0.975)
				bagWindow:SetVisible(true)
			
			local slots = Inspect.Item.Detail("sibg.003").slots
			local slotPosition = {col = 0, row = 0}
			for i=1, slots, 1 do
				bagWindow[i] = UI.CreateFrame("Frame", "emInventoryBag3_Slot" .. i, bagWindow)
					if i==1 then
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow, "TOPLEFT", 15, 33)
					else
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow[1], "TOPLEFT", slotPosition.col*52, slotPosition.row*52)
					end
					bagWindow[i]:SetHeight(50)
					bagWindow[i]:SetWidth(50)
					bagWindow[i]:SetBackgroundColor(0,0,0,0)
					bagWindow[i]:SetMouseMasking("limited")
					bagWindow[i]:SetVisible(true)
					
				if slotPosition.col < 3 then
					slotPosition.col = slotPosition.col + 1
				else
					slotPosition.col = 0
					slotPosition.row = slotPosition.row + 1
				end
				if i < 10 then
					bagWindow[i].name = "si03.00" .. i
				else
					bagWindow[i].name = "si03.0" .. i
				end
				local item = Inspect.Item.Detail(bagWindow[i].name)
				bagWindow[i].Event.RightClick = function()
					if bagWindow[i].attached then return end
					if item.bound == nil then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {3,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					elseif item.bind == "account" then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {3,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					end
					if #EM.UI.Send.Attachments == 0 then return end
					EM.UI.Send.AttachGrid.counter = EM.UI.Send.AttachGrid.counter or 1
					EM.UI.Send.AttachGrid:fill(EM.UI.Send.Attachments)
					if #EM.UI.Send.Attachments > 4 then
						EM.UI.Send:getElement().AttachScrollBar:SetRange(1, (#EM.UI.Send.Attachments-3))
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(true)
					else
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(false)
					end
					bagWindow[i].attached = true
				end
				
				bagWindow[i].Event.MouseIn = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0.18,0.36,0.41,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0.36,0.65,0.72,0.4)
					end
					Command.Tooltip(item.id)
				end
				
				bagWindow[i].Event.MouseOut = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0,0,0,0)
					end
					Command.Tooltip(nil)
				end
			end
			
			EM.UI.Inventory.Bags[3] = bagWindow

		end
	end
end

function UI.Native.BagInventory4.Event:Loaded()
	if EM.UI.Tabs and EM.UI.Tabs:getActivePane() == 2 then
		if EM.UI.Inventory.Bags[4] and not EM.UI.Inventory.Bags[4]:GetVisible() and UI.Native.BagInventory4:GetLoaded() then
			EM.UI.Inventory.Bags[4]:SetVisible(true)
		elseif EM.UI.Inventory.Bags[4] and EM.UI.Inventory.Bags[4]:GetVisible() and not UI.Native.BagInventory4:GetLoaded() then
			EM.UI.Inventory.Bags[4]:SetVisible(false)
		else
			tableAdd(EM.UI.Inventory.Bags, 4)
			local bagWindow = UI.CreateFrame("Frame", "emInventoryBag4", EM.Context.Inventory)
				bagWindow:SetPoint("TOPLEFT", UI.Native.BagInventory4, 0.01688, 0)
				bagWindow:SetPoint("BOTTOMRIGHT", UI.Native.BagInventory4, 0.96625, 0.975)
				bagWindow:SetVisible(true)
			
			local slots = Inspect.Item.Detail("sibg.004").slots
			local slotPosition = {col = 0, row = 0}
			for i=1, slots, 1 do
				bagWindow[i] = UI.CreateFrame("Frame", "emInventoryBag4_Slot" .. i, bagWindow)
					if i==1 then
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow, "TOPLEFT", 15, 33)
					else
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow[1], "TOPLEFT", slotPosition.col*52, slotPosition.row*52)
					end
					bagWindow[i]:SetHeight(50)
					bagWindow[i]:SetWidth(50)
					bagWindow[i]:SetBackgroundColor(0,0,0,0)
					bagWindow[i]:SetMouseMasking("limited")
					bagWindow[i]:SetVisible(true)
					
				if slotPosition.col < 3 then
					slotPosition.col = slotPosition.col + 1
				else
					slotPosition.col = 0
					slotPosition.row = slotPosition.row + 1
				end
				if i < 10 then
					bagWindow[i].name = "si04.00" .. i
				else
					bagWindow[i].name = "si04.0" .. i
				end
				local item = Inspect.Item.Detail(bagWindow[i].name)
				bagWindow[i].Event.RightClick = function()
					if bagWindow[i].attached then return end
					if item.bound == nil then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {4,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					elseif item.bind == "account" then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {4,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					end
					if #EM.UI.Send.Attachments == 0 then return end
					EM.UI.Send.AttachGrid.counter = EM.UI.Send.AttachGrid.counter or 1
					EM.UI.Send.AttachGrid:fill(EM.UI.Send.Attachments)
					if #EM.UI.Send.Attachments > 4 then
						EM.UI.Send:getElement().AttachScrollBar:SetRange(1, (#EM.UI.Send.Attachments-3))
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(true)
					else
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(false)
					end
					bagWindow[i].attached = true
				end
				
				bagWindow[i].Event.MouseIn = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0.18,0.36,0.41,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0.36,0.65,0.72,0.4)
					end
					Command.Tooltip(item.id)
				end
				
				bagWindow[i].Event.MouseOut = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0,0,0,0)
					end
					Command.Tooltip(nil)
				end
			end
			
			EM.UI.Inventory.Bags[4] = bagWindow

		end
	end
end

function UI.Native.BagInventory5.Event:Loaded()
	if EM.UI.Tabs and EM.UI.Tabs:getActivePane() == 2 then
		if EM.UI.Inventory.Bags[5] and not EM.UI.Inventory.Bags[5]:GetVisible() and  UI.Native.BagInventory5:GetLoaded() then
			EM.UI.Inventory.Bags[5]:SetVisible(true)
		elseif EM.UI.Inventory.Bags[5] and EM.UI.Inventory.Bags[5]:GetVisible() and not UI.Native.BagInventory5:GetLoaded() then
			EM.UI.Inventory.Bags[5]:SetVisible(false)
		else
			--print("Bag 5 was Opened and needs frame creation")
			tableAdd(EM.UI.Inventory.Bags, 5)
			local bagWindow = UI.CreateFrame("Frame", "emInventoryBag5", EM.Context.Inventory)
				bagWindow:SetPoint("TOPLEFT", UI.Native.BagInventory5, 0.01688, 0)
				bagWindow:SetPoint("BOTTOMRIGHT", UI.Native.BagInventory5, 0.96625, 0.975)
				bagWindow:SetVisible(true)
			
			local slots = Inspect.Item.Detail("sibg.005").slots
			local slotPosition = {col = 0, row = 0}
			for i=1, slots, 1 do
				bagWindow[i] = UI.CreateFrame("Frame", "emInventoryBag5_Slot" .. i, bagWindow)
					if i==1 then
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow, "TOPLEFT", 15, 33)
					else
						bagWindow[i]:SetPoint("TOPLEFT", bagWindow[1], "TOPLEFT", slotPosition.col*52, slotPosition.row*52)
					end
					bagWindow[i]:SetHeight(50)
					bagWindow[i]:SetWidth(50)
					bagWindow[i]:SetBackgroundColor(0,0,0,0)
					bagWindow[i]:SetMouseMasking("limited")
					bagWindow[i]:SetVisible(true)
					
				if slotPosition.col < 3 then
					slotPosition.col = slotPosition.col + 1
				else
					slotPosition.col = 0
					slotPosition.row = slotPosition.row + 1
				end
				if i < 10 then
					bagWindow[i].name = "si05.00" .. i
				else
					bagWindow[i].name = "si05.0" .. i
				end
				local item = Inspect.Item.Detail(bagWindow[i].name)
				bagWindow[i].Event.RightClick = function()
					if bagWindow[i].attached then return end
					if item.bound == nil then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {5,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					elseif item.bind == "account" then
						tableAdd(EM.UI.Send.Attachments, { { key = item.id, value = item.icon, slot = {5,i} }, { value = item.name, color = 'FFFFFF' }, { value = (item.stack or 1), color = 'FFFFFF' } })
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					end
					if #EM.UI.Send.Attachments == 0 then return end
					EM.UI.Send.AttachGrid.counter = EM.UI.Send.AttachGrid.counter or 1
					EM.UI.Send.AttachGrid:fill(EM.UI.Send.Attachments)
					if #EM.UI.Send.Attachments > 4 then
						EM.UI.Send:getElement().AttachScrollBar:SetRange(1, (#EM.UI.Send.Attachments-3))
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(true)
					else
						EM.UI.Send:getElement().AttachScrollBar:SetVisible(false)
					end
					bagWindow[i].attached = true
				end
				
				bagWindow[i].Event.MouseIn = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0.18,0.36,0.41,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0.36,0.65,0.72,0.4)
					end
					Command.Tooltip(item.id)
				end
				
				bagWindow[i].Event.MouseOut = function()
					if bagWindow[i].attached then
						bagWindow[i]:SetBackgroundColor(0,0,0,0.4)
					else
						bagWindow[i]:SetBackgroundColor(0,0,0,0)
					end
					Command.Tooltip(nil)
				end
			end
			
			EM.UI.Inventory.Bags[5] = bagWindow
			
			--[[EM.UI.Inventory.Bags[5].Event.RightClick = function() 
				print("Left = " .. EM.UI.Inventory.Bags[5]:GetLeft())
				print("Top = " .. EM.UI.Inventory.Bags[5]:GetTop()) 
				print("Right = " .. EM.UI.Inventory.Bags[5]:GetRight()) 
				print("Bottom = " .. EM.UI.Inventory.Bags[5]:GetBottom()) 
				dump(Inspect.Mouse()) end]]--
		end
	end
end
