local toc, privateData = ...
local AddonId = toc.identifier

EM.Utility = {}

function EM.Utility.ClearFocus()
	EM.UI.Send.element.ToField.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.ToField.element.textfield:SetText("")
	EM.UI.Send.element.SubjectField.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.SubjectField.element.textfield:SetText("")
	EM.UI.Send.element.MessageField:SetKeyFocus(false)
	EM.UI.Send.element.MessageField:SetText("")
	EM.UI.Send.element.SendMoneyRadio:SetSelected(true, true)
	EM.UI.Send.element.SentMoneySilver.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.SentMoneySilver.element.textfield:SetText("")
	EM.UI.Send.element.SentMoneyGold.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.SentMoneyGold.element.textfield:SetText("")
	EM.UI.Send.element.SentMoneyPlat.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.SentMoneyPlat.element.textfield:SetText("")
	EM.UI.Send.element.AttachGrid.values = {}
	EM.UI.Send.element.AttachGrid.counter = 1
	EM.UI.Send.Attachments = {}
	EM.UI.Send.element.AttachGrid:fill()
	EM.UI.Send.element.CostSilver:update({text = '25'})
	EM.UI.Send.element.CostGoldIcon:update({visible = false})
	EM.UI.Send.element.CostGold:update({text = ''})
	EM.UI.Send.element.CostPlatIcon:update({visible = false})
	EM.UI.Send.element.CostPlat:update({text = ''})
	EM.UI.Send.element.btnSend:SetEnabled(false)
end

function EM.Utility.ClearMessage()
	EM.UI.Send.element.ToField.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.ToField.element.textfield:SetText("")
	EM.UI.Send.element.SubjectField.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.SubjectField.element.textfield:SetText("")
	EM.UI.Send.element.MessageField:SetKeyFocus(false)
	EM.UI.Send.element.MessageField:SetText("")
	EM.UI.Send.element.SendMoneyRadio:SetSelected(true, true)
	EM.UI.Send.element.SentMoneySilver.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.SentMoneySilver.element.textfield:SetText("")
	EM.UI.Send.element.SentMoneyGold.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.SentMoneyGold.element.textfield:SetText("")
	EM.UI.Send.element.SentMoneyPlat.element.textfield:SetKeyFocus(false)
	EM.UI.Send.element.SentMoneyPlat.element.textfield:SetText("")
	EM.UI.Send.element.AttachGrid.values = {}
	EM.UI.Send.element.AttachGrid.counter = 1
	EM.UI.Send.element.AttachGrid:fill()
	EM.UI.Send.element.CostSilver:update({text = '25'})
	EM.UI.Send.element.CostGoldIcon:update({visible = false})
	EM.UI.Send.element.CostGold:update({text = ''})
	EM.UI.Send.element.CostPlatIcon:update({visible = false})
	EM.UI.Send.element.CostPlat:update({text = ''})
	EM.UI.Send.element.btnSend:SetEnabled(false)
end

function EM.Utility.Coin(coin)

	if not coin then return end

	local plat = 0
	local gold = 0
	local silver = 0
	local len = string.len(coin)
	
	if len < 5 then
		repeat
			coin = "0" .. coin
		until string.len(coin) == 5
		len = string.len(coin)
	end
	
	if coin == 0 or nil then
		return plat,gold,silver
	else
		plat = string.sub(coin,1,len-4)
		gold = string.sub(coin,len-3,len-2)
		silver = string.sub(coin,len-1,len)
		return plat,gold,silver
	end
end

function EM.Utility.AttachSetup()

	local attachments = {}
	
	if #EM.UI.Send.Attachments == 0 then return end

	if #EM.UI.Send.Attachments > 6 then
		for idx = 1, 6, 1 do
			table.insert(attachments, EM.UI.Send.Attachments[1][1].key)
			table.remove(EM.UI.Send.Attachments, 1)
		end
		if #EM.UI.Send.Attachments > 4 then
			EM.UI.Send.element.AttachScrollBar:SetRange(1, (#EM.UI.Send.Attachments-3))
			EM.UI.Send.element.AttachScrollBar:SetVisible(true)
			EM.UI.Send.element.AttachGrid.counter = EM.UI.Send.element.AttachGrid.counter - 1
		end
		if EM.UI.Send.element.AttachGrid.counter == 0 then
			EM.UI.Send.element.AttachGrid.counter = 1
		end
		EM.UI.Send.element.AttachScrollBar:SetPosition(EM.UI.Send.element.AttachGrid.counter)
		EM.UI.Send.element.AttachGrid:fill(EM.UI.Send.Attachments)
	else
		for slot, data in ipairs(EM.UI.Send.Attachments) do
			table.insert(attachments, data[1].key)
		end
		EM.UI.Send.Attachments = {}
		if #EM.UI.Send.Attachments > 4 then
			EM.UI.Send.element.AttachScrollBar:SetRange(1, (#EM.UI.Send.Attachments-3))
			EM.UI.Send.element.AttachScrollBar:SetVisible(true)
			EM.UI.Send.element.AttachGrid.counter = EM.UI.Send.element.AttachGrid.counter - 1
		else
			EM.UI.Send.element.AttachScrollBar:SetVisible(false)
			EM.UI.Send.element.AttachGrid.counter = 1
		end
		if EM.UI.Send.element.AttachGrid.counter == 0 then
			EM.UI.Send.element.AttachGrid.counter = 1
		end
		EM.UI.Send.element.AttachScrollBar:SetPosition(EM.UI.Send.element.AttachGrid.counter)
		EM.UI.Send.element.AttachGrid:fill()
	end
	return attachments
end

function EM.Utility.RecipientSetup()

	local recipient = nil
	local multipleRecipients = false

	if #EM.UI.Send.Recipients == 0 then return end
	
	if #EM.UI.Send.Recipients > 1 then 
		multipleRecipients = true
		recipient = EM.UI.Send.Recipients[1]
		table.remove(EM.UI.Send.Recipients, 1)
	else
		multipleRecipients = false
		recipient = EM.UI.Send.Recipients[1]
		if #EM.UI.Send.Attachments == 0 then
			table.remove(EM.UI.Send.Recipients, 1)
		end
	end
	
	return recipient, multipleRecipients
end